//
//  Created by Christian Gasser on 03/08/2012.
//  Copyright (c) 2012 Lakeside. All rights reserved.
//

// A simple SOAP-client used to call SOSI-GW
// Error handling is very limited and timeouts are not handled appropriately!

// This implementation is not thread-safe!!

#import "SOSISoapClient.h"

@implementation SOSISoapClient {
    NSMutableData *_webData;
    NSString *_endpoint;
    SOSICallbackBlock _callback;
}


+ (id)createWithEndpoint:(NSString *)endpoint {
    SOSISoapClient *client = [[self alloc] init];
    client->_endpoint = endpoint;
    return client;
}

- (void)postRequest:(NSString *)request withSoapAction:(NSString *)action andCallback:(SOSICallbackBlock)callback {

    NSLog(@"Posting request: %@", request);

    _callback = callback;

    NSURL *url = [NSURL URLWithString:_endpoint];
    NSMutableURLRequest *theRequest = [NSMutableURLRequest requestWithURL:url];
    NSString *msgLength = [NSString stringWithFormat:@"%d", [request length]];

    [theRequest addValue:@"text/xml; charset=utf-8" forHTTPHeaderField:@"Content-Type"];
    [theRequest addValue:action forHTTPHeaderField:@"SOAPAction"];
    [theRequest addValue:msgLength forHTTPHeaderField:@"Content-Length"];
    [theRequest setHTTPMethod:@"POST"];
    [theRequest setHTTPBody:[request dataUsingEncoding:NSUTF8StringEncoding]];

    NSURLConnection *theConnection = [[NSURLConnection alloc] initWithRequest:theRequest delegate:self];

    if (theConnection) {
        _webData = [NSMutableData data];
    }
    else {
        NSLog(@"theConnection is NULL");
        _callback(nil);
    }
}

/* Start NSURLConnection delegate methods */
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
    [_webData setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    [_webData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    NSLog(@"ERROR while posting to server: %@", error);
    _callback(nil);
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    NSLog(@"DONE. Received bytes: %d", [_webData length]);
    NSString *response = [[NSString alloc] initWithBytes:[_webData mutableBytes] length:[_webData length] encoding:NSUTF8StringEncoding];
    NSLog(@"Received: %@", response);
    _callback(response);

}
/* End NSURLConnection delegate methods */


@end